/*
vbei.c -> vbei.exe

LSI-C86 3.30c trial
	lcc -O vbei.c -lintlib -ltinymain.obj

Turbo C/C++ 1.01
	tcc vbei.c

sava/LP-Project. 1996-2004.
*/

#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#if defined (__TURBOC__)
#include <alloc.h>
#endif

const int	major = 1;
const int	minor = 0x11;
const char	ver_trailer[] = "";

typedef unsigned char		byte;
typedef unsigned short		word;
typedef unsigned long		dword;

typedef struct VESAI
	{
	char		id[4];
	word		ver;
	char far *	oemstr;
	byte		capa[4];
	word far *	vm;
	word		vmem;
	word		oemrev;
	char far *	oemvendor;
	char far *	oemproduct;
	char far *	oemrevstr;
/*
	word		afver;
	word far *	afvm;
*/
	} VESAI;

typedef struct VESAM
	{
	word		attr;
	byte		attrA;
	byte		attrB;
	word		gra;
	word		size;
	word		segA;
	word		segB;
	dword		sel;
	word		linebytes;
	/* VESA 1.2+ */
	word		resoX;
	word		resoY;
	byte		width;
	byte		height;
	byte		planes;
	byte		bitspixel;
	byte		banks;
	byte		model;
	byte		banksize;
	byte		pages;
	byte		reserved;		/* db 1 */
	
	byte		maskR;
	byte		posR;
	byte		maskG;
	byte		posG;
	byte		maskB;
	byte		posB;
	byte		maskReserved;
	byte		posReserved;
	byte		dcolor;
	/* VBE 2.0+ */
	dword		physbase;
	dword		offscrn;		/* 2.0 only */
	word		offscrnsize;	/* 2.0 only */
	/* VBE 3.0+ */
	word		lfb_linebytes;
	byte		bank_pages;
	byte		lfb_pages;
	byte		lfb_maskR;
	byte		lfb_posR;
	byte		lfb_maskG;
	byte		lfb_posG;
	byte		lfb_maskB;
	byte		lfb_posB;
	byte		lfb_maskReserved;
	byte		lfb_posReserved;
	dword		max_dotclock;
	} VESAM;

typedef struct vbe_bitpos
	{
	byte		maskR;
	byte		posR;
	byte		maskG;
	byte		posG;
	byte		maskB;
	byte		posB;
	byte		maskReserved;
	byte		posReserved;
	} vbe_bitpos;


typedef struct VBEPM
	{
	word	off_func5;
	word	off_func7;
	word	off_func9;
	word	off_portmem;
	} VBEPM;


typedef struct VBESUP
	{
	char		id[7];
	word		ver;
	byte		capa[8];
	word		oemrev;
	char far *	oemvendor;
	char far *	oemproduct;
	char far *	oemrevstr;
	char far *	oemstr;
	byte		d[221];
	} VBESUP;

typedef struct PMINFOBLK
	{
	char		id[4];
	word		off_bios;
	word		off_init;
	word		sel_biosds;
	word		sel_a0000;
	word		sel_b0000;
	word		sel_b8000;
	word		sel_cs_alias;
	byte		in_pm;
	byte		sum;
	} PMINFOBLK;

typedef struct ROMHDR
	{
	word		id;						/* 0xAA55 - 0x55, 0xAA */
	byte		init_pages;
	byte		init_entry;				/* jmp cmd */
	word		init_relative_ofs;
	byte		reserved[18];
	word		pcir_ofs;
	} ROMHDR;

typedef struct ROMPCIR
	{
	byte		id[4]	; /* 'PCIR' */
	word		vendor_id;
	word		dev_id;
	word		vpd_ofs;
	word		pcid_len;
	byte		pcid_rev;
	byte		class_code[3];
	word		pages;
	word		rom_rev;
	byte		code_type;
	byte		ind;
	word		reserved;
	} ROMPCIR;


void
Put_f(char far * lp)
{
	char	c;
	
	if (!lp)	{ puts("(null!!)"); return; }
	
	while('\0' != (c = *lp++))	putchar(c);
}

void
Put_fq(char far *lp, const char *header, const char *trailer)
{
	if (!lp)	{ printf("(null!!)"); return; }
	printf(header);
	Put_f(lp);
	printf(trailer);
}

int
QueryRomSize(word seg, long *initial_size, word *pcir)
{
	ROMHDR far *r;
	long len;
	ROMPCIR far *rp;
	word rpw;
	
	r = (ROMHDR far *)((dword)seg << 16);
	
	if (r->id != 0xAA55) return 0;
	len = 512L * r->init_pages;
	if (len <= 65536)
		{
		rpw = r->pcir_ofs;
		if ((long)rpw + sizeof(ROMHDR) <= len)
			{
			rp = (ROMPCIR far *)(((dword)seg << 16) | rpw);
			if (rp->id[0] == 'P' && rp->id[1] == 'C' && rp->id[2] == 'I' && rp->id[3] == 'R')
				{
				}
			else
				rpw = 0;
			}
		else
			rpw = 0;
		}
	
	if (initial_size != NULL) *initial_size = len;
	if (pcir != NULL) *pcir = rpw;
	
	return 1;
}

int
QueryVesai(VESAI * vi, int chkvbe2)
{
	union REGS		r;
	struct SREGS	sr;
	
	if (chkvbe2) memcpy(vi, "VBE2", 4);
	sr.es = FP_SEG((void far *)vi);
	r.x.di = FP_OFF(vi);
	r.x.ax = 0x4f00;
	int86x(0x10, &r, &r, &sr);
	
	return r.x.ax;
}


int
QueryVesam(VESAM * vm, word mode)
{
	union REGS		r;
	struct SREGS	sr;
	void far *		tv;

	memset(vm, 0, 256);
	tv = (void far *)vm;
	sr.es = FP_SEG(tv);
	r.x.di = FP_OFF(tv);
	r.x.ax = 0x4f01;
	r.x.cx = mode;
	int86x(0x10, &r, &r, &sr);
	
	return r.x.ax;
}

int
QueryVbesup(VBESUP *vs, unsigned func)
{
	union REGS		r;
	struct SREGS	sr;
	
	sr.es = FP_SEG((void far *)vs);
	r.x.di = FP_OFF(vs);
	r.h.ah = 0x4f;
	r.h.al = func;
	r.x.bx = 0;
	int86x(0x10, &r, &r, &sr);
	
	return r.x.ax;
}

int
QueryVbe2pm32(VBEPM far ** vp, word * bytes)
{
	union REGS		r;
	struct SREGS	sr;

	r.x.ax = 0x4f0a;
	r.x.bx = 0;
	r.x.cx = r.x.di = 0;
	sr.es = 0;
	int86x(0x10, &r, &r, &sr);
	*vp = (VBEPM far *)MK_FP(sr.es, r.x.di);
	*bytes = r.x.cx;
	
	return r.x.ax;
}


PMINFOBLK far *
ScanPMInfoBlock(word sel_bios, word off_top, word length)
{
	PMINFOBLK far *pmi;
	byte far *fp;
	int i;
	byte s;
	
	if (length < sizeof(PMINFOBLK) || ((dword)off_top + (dword)length) > 0xffffUL)
		return (PMINFOBLK far *)0L;
	
	fp = (byte far *)(((dword)sel_bios << 16) | off_top);
	length -= sizeof(PMINFOBLK);
	
	while(1)
		{
		if (fp[0] == 'P' && fp[1] == 'M' && fp[2] == 'I' && fp[3] == 'D')
			{
			pmi = (PMINFOBLK far *)fp;
			if (pmi->sel_a0000 == 0xa000U ||
				pmi->sel_b0000 == 0xb000U ||
				pmi->sel_b8000 == 0xb800U
#ifdef CHECK_STRICT
				|| pmi->sel_cs_alias == sel_bios
				|| pmi->sel_biosds == 0x0000U
				|| pmi->in_pm == 0
#endif
				) {
				s = 0;
				for(i=0; i<sizeof(PMINFOBLK); i++)
					s += fp[i];
				if (s == 0)
					break;
				}
			}
		pmi = (PMINFOBLK far *)0L;
		fp++;
		if (length == 0) break;
		--length;
		}
	
	return pmi;
}


int
PrintWordTable(word far *lpw)
{
	const int		clim = 12;
	int				cntp;
	int				cnt;
	word			w;

	if (0xffffU == *lpw)	puts("    (none)");
	cntp = cnt = 0;
	for(;;)
		{
		w = *lpw++;
		if (0xffffU == w)	break;
		if (0 == cnt)	printf("\n    ");
		else			printf(",");
		printf("%4Xh", w);
		cnt++;
		cntp++;
		if (cnt >= clim)	cnt = 0;
		}
	putchar('\n');
	
	return cntp;
}


void
ErrVesa(word stat)
{
	if (stat == 0x004f)	return;
	printf("Result... %04Xh  ",stat);
	if (0x4f != (byte)stat)	puts("(Function not supported)");
	else
		switch( stat >> 8 )
			{
			case 1:
				puts("(Function call failed)");
				break;
			case 2:
				puts("(Function not supported in current H/W config.)");
				break;
			case 3:
				puts("(Function not valid in current Video Mode)");
				break;
			default:
				puts("(Unknown error)");
			}
}

void
dumpmem(byte far *s, unsigned len)
{
	unsigned bpl = 16;
	unsigned ofs = 0;
	
	while(len)
		{
		if ((ofs % bpl) == 0) printf("%04X", ofs);
		printf(" %02x", *s);
		s++;
		len--;
		if ((ofs % bpl) == (bpl - 1)) printf("\n");
		ofs++;
		}
	
}

void
dumpmem_um(byte far *s, byte far *modified, unsigned len)
{
	unsigned bpl = 16;
	unsigned ofs = 0;
	
	while(len)
		{
		if ((ofs % bpl) == 0) printf("%04X", ofs);
		if (*modified) printf(" %02x", *s);
		else printf(" --");
		modified++;
		s++;
		len--;
		if ((ofs % bpl) == (bpl - 1)) printf("\n");
		ofs++;
		}
	
}



void
PrintVgaBiosInfo(void)
{
	union REGS r;
	struct SREGS sr;
	
	puts("[VGA BIOS information]");
	
	r.x.ax = 0x3510;
	intdosx(&r, &r, &sr);
	printf("BIOS Entry(10h) %04X:%04Xh\n", sr.es, r.x.bx);
	r.x.ax = 0x351d;
	intdosx(&r, &r, &sr);
	printf("CRTC Table(1Dh) %04X:%04Xh\n", sr.es, r.x.bx);
	r.x.ax = 0x3542;
	intdosx(&r, &r, &sr);
	printf("Older BIOS(42h) %04X:%04Xh\n", sr.es, r.x.bx);
	r.x.ax = 0x351f;
	intdosx(&r, &r, &sr);
	printf("CGA Chars (1Fh) %04X:%04Xh\n", sr.es, r.x.bx);
	r.x.ax = 0x3543;
	intdosx(&r, &r, &sr);
	printf("CGA Chars (43h) %04X:%04Xh\n", sr.es, r.x.bx);
}


void
PrintVgaRomInfo(word bseg)
{
	ROMHDR far *pr;
	ROMPCIR far *prp;
	long romlen;
	word pcir_off;
	
	printf("[VGA-ROMBIOS (%X0h) information]\n", bseg);
	
	if (!QueryRomSize(bseg, &romlen, &pcir_off))
		{
		printf("Rom is not present at %04X:0000\n", bseg);
		}
	
	pr = (ROMHDR far *)((dword)bseg << 16);
	prp = (pcir_off != 0) ? (ROMPCIR far *)((dword)pr + pcir_off) : 0L;
	
	printf("Initial Size    %d pages (%ld bytes)\n", pr->init_pages, romlen);
	printf("Initial Entry   %02X %02X %02X"
			, pr->init_entry
			, (pr->init_relative_ofs & 0xff)
			, pr->init_relative_ofs >> 8);
	if (pr->init_entry == 0xe9)
		{
		printf(" (jmp %04Xh)", pr->init_relative_ofs + (word)(pr) + 6);
		}
	else if (pr->init_entry == 0xeb)
		{
		printf(" (jmp short %04Xh)", (int)(signed char)(pr->init_relative_ofs & 0xff) + (word)(pr) + 5);
		}

	printf("\n");
	
	if (prp != 0L)
		{
		printf("[PCI Extended ROM information]\n");
		printf("PCIRom Header   %Fph\n", prp);
		printf("Vendor ID       %04Xh\n", prp->vendor_id);
		printf("Device ID       %04Xh\n", prp->dev_id);
		printf("Vital PD at     %04X:%04Xh", (dword)prp >> 16, prp->vpd_ofs);
		if (prp->vpd_ofs == 0)
			{
			printf(" (none)");
			}
		printf("\n");
		printf("PCID size       %Xh (%d bytes)\n", prp->pcid_len, prp->pcid_len);
		printf("PCID revision   %d\n", prp->pcid_rev);
		printf("Class code      %02X%02X%02Xh (base %02Xh sub %02Xh progIF %02Xh)\n"
				, prp->class_code[2]
				, prp->class_code[1]
				, prp->class_code[0]
				, prp->class_code[2]
				, prp->class_code[1]
				, prp->class_code[0]
				);
		printf("Image Size      %d pages (%ld bytes)\n", prp->pages, (long)prp->pages * 512L);
		printf("ROM OEM rev.    %04Xh\n", prp->rom_rev);
		printf("Code type       %02Xh ", prp->code_type);
		switch(prp->code_type)
			{
			case 0x00:
				printf("(x86-PC)\n"); break;
			case 0x01:
				printf("(PCI open firmware standard)\n"); break;
			default:
				printf("(unknown)\n"); break;
			}
		printf("PCID indicator  %02Xh", prp->ind);
		if (prp->ind & 0x80) printf(" (last image)");
		printf("\n");
		}
}


void
PrintVesai(VESAI * vi)
{
	
	puts("[VESA BIOS information]");
	printf("VBE Version     %x.%x\n", vi->ver >> 8, vi->ver & 255);
	printf("OEM String at   %Fph", vi->oemstr);
	if (FP_SEG(vi->vm) == FP_SEG((void far *)vi))
		printf(" (built in VbeInfoBlock)");
	printf("\n");
	printf("OEM String      "); Put_fq(vi->oemstr, "\"", "\"\n");
	printf("Capabilities    %02X%02X%02X%02Xh",
	       vi->capa[3], vi->capa[2], vi->capa[1], vi->capa[0]);
	if (vi->capa[0] & 7)
		{
		printf("  (");
		if (vi->capa[0] & 1)	printf(" 8bitDAC");
		if (vi->capa[0] & 2)	printf(" NonVGA");
		if (vi->capa[0] & 4)	printf(" OldRAMDAC");
		if (vi->ver >= 0x0300)
			{
			if (vi->capa[0] & 8)
				{
				if (vi->capa[0] & 0x10)	printf(" StereoSync-EVC");
				else					printf(" StereoSync-VESA");
				}
			}
		printf(" )");
		}
	printf("\nTotal Memory    %ld Kbytes\n", (unsigned long)(unsigned)vi->vmem * 64L);
	
	if (vi->ver >= 0x0200)
		{
		printf("OEM Revision    %x.%x\n", vi->oemrev >> 8, vi->oemrev & 255);
		printf("OEM VendorName  "); Put_fq(vi->oemvendor, "\"", "\"\n");
		printf("OEM Product     "); Put_fq(vi->oemproduct, "\"", "\"\n");
		printf("OEM RevisionStr "); Put_fq(vi->oemrevstr, "\"", "\"\n");
		}
	
	printf("VideoMode Table %Fph", vi->vm);
	if (FP_SEG(vi->vm) == FP_SEG((void far *)vi))
		printf(" (built in VbeInfoBlock)");
	printf("\nVideo Modes...");
	
	PrintWordTable(vi->vm);
	
	return;
}

void
PrintVbesup(VBESUP *vs)
{
	int i;
	
	printf("[");
	for(i=0; i<sizeof(vs->id); i++)
		{
		if ((byte)(vs->id[i]) == 0xff) break;
		printf("%c", vs->id[i]);
		}
	printf("]\n");
	printf("Version %x.%x\n", vs->ver >> 8, vs->ver & 0xff);
	printf("Capabilities ");
	i = sizeof(vs->capa);
	while(--i) printf("%02x", vs->capa[i]);
	printf("h\n");
	printf("OEM Revision    %x.%x\n", vs->oemrev >> 8, vs->oemrev & 0xff);
	printf("OEM VendorName  "); Put_fq(vs->oemvendor, "\"", "\"\n");
	printf("OEM Product     "); Put_fq(vs->oemproduct, "\"", "\"\n");
	printf("OEM RevisionStr "); Put_fq(vs->oemrevstr, "\"", "\"\n");
	printf("OEM String      "); Put_fq(vs->oemstr, "\"", "\"\n");
}

void
print_bitposm(vbe_bitpos *vm, int bits, int is_yuv, int print_bitdigit)
{
	char bt[68];
	int i;
	int bitmax;
	
	bitmax = bits;
	if (bitmax < (vm->posReserved + vm->maskReserved))
		bitmax = vm->posReserved + vm->maskReserved;
	bitmax = (bitmax + 7) & 0xfff8;
	if (bitmax >= sizeof(bt)) bitmax = sizeof(bt) - 1;
	for(i=0; i< bitmax; i++) bt[i] = '.';
	bt[bitmax] = '\0';
	
	if (print_bitdigit)
		printf("MSB(bit%d)", bitmax - 1);
	
	for(i=vm->posR; i>=0 && i<bits && i<vm->posR+vm->maskR; i++)
		bt[i] = is_yuv ? 'v' : 'r';
	for(i=vm->posG; i>=0 && i<bits && i<vm->posG+vm->maskG; i++)
		bt[i] = is_yuv ? 'y' : 'g';
	for(i=vm->posB; i>=0 && i<bits && i<vm->posB+vm->maskB; i++)
		bt[i] = is_yuv ? 'u' : 'b';
	for(i=vm->posReserved; i>=0 && i<bitmax && i<vm->posReserved+vm->maskReserved; i++)
		bt[i] = 'a';
	
	printf(" ");
	for(i=0; i<bitmax; i++)
		putchar(bt[bitmax - i - 1]);
	
	if (print_bitdigit)
		printf(" LSB(bit0)");
}


void
print_bitpos(vbe_bitpos *vm, int bits, int is_yuv, const char *heading, const char *trailing)
{
	char	*h, *t, hs[128];
	int		i;
	
	if (heading != NULL)
		{
		h = (char *)heading;
		i = strlen(heading);
		hs[i] = '\0';
		while(i--)
			hs[i] = ' ';
		}
	else
		{
		h = "";
		*hs = '\0';
		}
	
	t = (trailing != NULL) ? (char *)trailing : "";
	
	printf("%sBit position(%c) %s", h, is_yuv ? 'V' : 'R', t);
	printf("Pos%2d Size%2d", vm->posR, vm->maskR);
	printf(" (bit %2d-%-2d : ", vm->posR + vm->maskR - 1, vm->posR );
	printf("%d Bit%s)\n", vm->maskR, (1 < vm->maskR) ? "s" : "");
	printf("%s            (%c) %s", hs, is_yuv ? 'Y' : 'G', t);
	printf("Pos%2d Size%2d", vm->posG, vm->maskG);
	printf(" (bit %2d-%-2d : ", vm->posG + vm->maskG - 1, vm->posG );
	printf("%d Bit%s)\n", vm->maskG, (1 < vm->maskG) ? "s" : "");
	printf("%s            (%c) %s", hs, is_yuv ? 'U' : 'B', t);
	printf("Pos%2d Size%2d", vm->posB, vm->maskB);
	printf(" (bit %2d-%-2d : ", vm->posB + vm->maskB - 1, vm->posB );
	printf("%d Bit%s)\n", vm->maskB, (1 < vm->maskB) ? "s" : "");
	printf("%s     (Reserved) %s", hs, t);
	printf("Pos%2d Size%2d", vm->posReserved, vm->maskReserved);
	
	if (vm->maskReserved)
		{
		printf(" (bit %2d-%-2d : ", vm->posReserved + vm->maskReserved - 1, vm->posReserved );
		printf("%d Bit%s)\n", vm->maskReserved, (1 < vm->maskReserved) ? "s" : "");
		}
	else
		puts(" (none)");

	printf("%sBit positioning %s", h, t);
	print_bitposm(vm, bits, is_yuv, 1);
	printf("\n");

}

void
PrintVesam(VESAM * vm, word ver)
{
	char	*mdl[8] = { "Text", "CGA", "Hercules", "EGA/VGA planar",
	                    "Packed pixel", "Non-Chain4", "Direct color", "YUV" };
	char	*rw[4] = { "???", "Read", "Write", "Read/Write" };

	if (0 == (vm->attr & 1))	{ printf("Not supported.\n"); return; }
	printf("Mode Attributes %04Xh  ( ", vm->attr);
	if (vm->attr & 4)	printf("ConsoleBIOS ");
	printf((vm->attr & 8) ? "Color " : "Mono ");
	printf((vm->attr & 16) ? "Graphics " : "Text ");
	if (vm->attr & 32)	printf("NonVGA ");
	if (0 == (vm->attr & 64))	printf("Window ");
	if (vm->attr & 128)	printf("Linear ");
	
	if (ver >= 0x0300)
		{
		if (vm->attr & 0x100)	printf("DoubleScan ");
		if (vm->attr & 0x200)	printf("Interlaced ");
		if (vm->attr & 0x400)	printf("TripleBuffer ");
		if (vm->attr & 0x800)	printf("StreoScope ");
		if (vm->attr & 0x1000)	printf("DualStartAddress ");
		}
	
	puts(")");
	
	printf("Window A        ");
	if (vm->attrA & 1)
			printf("%04Xh  ( %s )\n", vm->segA, rw[ (vm->attrA >> 1) & 3 ]);
	else	puts("----");
	printf("Window B        ");
	if (vm->attrB & 1)
			printf("%04Xh  ( %s )\n", vm->segB, rw[ (vm->attrB >> 1) & 3 ]);
	else	puts("----");
	printf("Window Size     %d KBytes\n", vm->size);
	printf("Granularity     %d KBytes\n", vm->gra);
	printf("Window Func.    %Fph\n", vm->sel);
	printf("Bytes/Scanline  %d Bytes\n", vm->linebytes);
	
	if (0 == (vm->attr & 2))
		{
		if (ver >= 0x0200)
			{
			puts("** Warning - ModeAttributes D1 is zero (Extend infomation not available) **");
			}
		else
			{
			puts("** Extend infomation not available **");
			return;
			}
		}
	
	printf("Resolution      %dx%d\n", vm->resoX, vm->resoY);
	printf("Character size  %dx%d\n", vm->width, vm->height);
	printf("Memory plane(s) %d\n", vm->planes);
	printf("Bits per pixel  %d Bit%s\n", vm->bitspixel,(vm->bitspixel > 1) ? "s" : "" );
	printf("Memory model    %d (%s)\n", vm->model, (vm->model < 8) ? mdl[vm->model] : "???");
	printf("Bank(s)         %d Bank%s\n",vm->banks,(1 < vm->banks) ? "s" : "");
	printf("Bank size       %d KBytes\n", vm->banksize);
	printf("Image page(s)   %d Page%s\n",vm->pages,(1 < vm->pages) ? "s" : "");
	
	if (6 == (vm->model & 0xfe))
		{
		print_bitpos((vbe_bitpos *)&(vm->maskR), vm->bitspixel, (vm->model == 7), NULL, NULL);
		printf("DirectColorInfo %d", vm->dcolor);
		if (vm->dcolor & 3)
			{
			printf("  ( ");
			if (vm->dcolor & 1)	printf("ColorRamp-Programmable ");
			if (vm->dcolor & 2)	printf("ReservedField-usable ");
			printf(")");
			}
		putchar('\n');
		
		}
	
	if (ver >= 0x0200 && vm->attr & 128)
		{
		printf("FrameBuff addr. %08lXh\n", vm->physbase);
		printf("Offscrn offset  %08lXh\n", vm->offscrn);
		printf("Offscrn size    %d KBytes\n", vm->offscrnsize);
		}
	
	if (ver >= 0x0300)
		{
		printf("Max Pixel Clock %lu.%lu MHz\n", (unsigned long)(vm->max_dotclock / 1000000UL), (unsigned long)(vm->max_dotclock % 1000000UL));
		if (vm->attr & 128)
			{
			printf("LFB Bytes/Scanline   %d Bytes\n", vm->lfb_linebytes);
			printf("Banked Image page(s) %d Page%s\n",vm->bank_pages,(1 < vm->bank_pages) ? "s" : "");
			printf("LFB    Image page(s) %d Page%s\n",vm->lfb_pages,(1 < vm->lfb_pages) ? "s" : "");

			if (6 == (vm->model & 0xfe))
				print_bitpos((vbe_bitpos *)&(vm->lfb_maskR), vm->bitspixel, (vm->model == 7), "LFB ", " ");
			}
		}
}


void
PrintVesamS(VESAM * vm, word vmode, word ver, int pixmap)
{
	char	*rw[4] = { "??", "r ", "w ", "rw" };
#if 0
	char	*mdl[8] = { "Text ", "CGA  ", "Herc ", "VGA16", "Pixel",
	                    "NonC4", "Dcolr", "YUV  "};
#else
	char	*mdl[8] = { "txt", "cga", "mga", "vga", "pix",
	                    "nc4", "bpp", "yuv"};
#endif

	printf("%4X ", vmode);
	if (0 == (vm->attr & 1))	{ puts(" (Not supported)"); return; }
	
	if (vm->attr & 2)
		printf("%4dx%-4d %2d%s ", vm->resoX, vm->resoY,
		       vm->bitspixel,
		       (vm->model < 8) ? mdl[vm->model] : "???"
		      );
	else
		printf("----x---- ----- ");
		
	if ((vm->attrA & 1) && (0 == (vm->attr & 64)))
		printf("%04X%s ", vm->segA, rw[(vm->attrA >> 1) & 3]);
	else
		printf("------ ");
	if ((vm->attrB & 1) && (0 == (vm->attr & 64)))
		printf("%04X%s ", vm->segB, rw[(vm->attrB >> 1) & 3]);
	else
		printf("------ ");
	if (0 == (vm->attr & 64))
		printf("%2d %2d %Fp ", vm->size, vm->gra, vm->sel);
	else
	 	printf("-- -- ----:----- ");
	
	if (ver >= 0x0200 && vm->attr & 128 && vm->physbase)
		printf("%08lX", vm->physbase);
	else
		printf("--------");
	
	if (pixmap != 0 && (vm->model == 6 || vm->model == 7) && vm->bitspixel <= 32)
		{
		print_bitposm((vbe_bitpos *)&(vm->maskR), vm->bitspixel, (vm->model == 7), 0);
		}
	
	putchar('\n');
}


void
PrintVbeDPMS(void)
{
	union REGS r;
	struct SREGS sr;
	
	puts("[VESA DPMS(VBE/PM) Information]");
	r.x.ax = 0x4f10;
	r.x.bx = 0;
	r.x.di = 0;
	sr.es = 0;
	int86x(0x10, &r, &r, &sr);
	if (r.x.ax != 0x004f)
		{
		ErrVesa(r.x.ax);
		return;
		}
	printf("DPMS Version    %d.%d\n", r.h.bl >> 4, r.h.bl & 0x0f);
	printf("State Signals   %Xh", r.h.bh);
	if ((r.h.bh & 0x0f) != 0)
		{
		printf(" (");
		if (r.h.bh & 1) printf(" StandBy");
		if (r.h.bh & 2) printf(" Suspend");
		if (r.h.bh & 4) printf(" PowerOff");
		if (r.h.bh & 8) printf(" Reduced");
		printf(" )");
		}
	printf("\n");
	
	r.x.ax = 0x4f10;
	r.x.bx = 0x0002;
	int86(0x10, &r, &r);
	printf("Current Status  ");
	if (r.x.ax != 0x004f)
		{
		ErrVesa(r.x.ax);
		return;
		}
	printf("%Xh ", r.h.bh);
	switch(r.h.bh)
		{
		case 0: printf("(On)"); break;
		case 1: printf("(StandBy)"); break;
		case 2: printf("(Suspended)"); break;
		case 4: printf("(Off)"); break;
		case 8: printf("(Reduced)"); break;
		default:
			printf("(Error or Unknown)");
		}
	printf("\n");
}


void
PrintVbeDDC(void)
{
	union REGS r;
	struct SREGS sr;
	
	puts("[VESA VBE/DDC Information]");
	r.x.ax = 0x4f15;
	r.x.bx = 0;
	r.x.cx = 0;
	r.x.di = 0;
	sr.es = 0;
	int86x(0x10, &r, &r, &sr);
	if (r.x.ax != 0x004f)
		{
		ErrVesa(r.x.ax);
		return;
		}
	printf("DDC level       %X", r.h.bl);
	if (r.h.bl & 7)
		{
		printf("(");
		if (r.h.bl & 1) printf(" DDC1");
		if (r.h.bl & 2) printf(" DDC2");
		if (r.h.bl & 4) printf(" Blanked");
		printf(" )");
		}
	printf("\n");
	printf("EDID Trans Time %d second%s\n"
			, r.h.bh
			, (r.h.bh > 1) ? "s" : ""
			);
}


void
PrintEDID(byte *extbuf, int monitor_id, int block, int block_cnt)
{
	union REGS r;
	struct SREGS sr;
	byte *buf;
	int is_alloced;
	
	r.x.ax = 0x4f15;
	r.x.bx = 0;
	r.x.cx = 0;
	r.x.di = 0;
	sr.es = 0;
	int86x(0x10, &r, &r, &sr);
	if (r.x.ax != 0x004f)
		{
		ErrVesa(r.x.ax);
		return;
		}
	
	printf("[EDID]\n");
	
	if (extbuf)
		{
		buf = extbuf;
		is_alloced = 0;
		}
	else
		{
		buf = (byte *)malloc(128);
		is_alloced = 1;
		}
	
	while(block_cnt--)
		{
		memset(buf, 0, 128);
		r.x.ax = 0x4f15;
		r.x.bx = 0x0001;
		r.x.cx = monitor_id;
		r.x.dx = block;
		sr.es = ((unsigned long)(byte far *)buf >> 16);
		r.x.di = ((unsigned)buf);
		int86x(0x10, &r, &r, &sr);
		
		printf("\nBlock %d :");
		if (r.x.ax != 0x004f)
			{
			printf(" ");
			ErrVesa(r.x.ax);
			break;
			}
		printf("\n");
		dumpmem(buf, 128);
		block++;
		}
	if (is_alloced) free(buf);
}


void
PrintVbe2pm32(VBEPM far *vp, word bytes)
{
	byte far *	bvp;
	dword 		dw;
	word		w;

	if (NULL == vp)	{ puts(" (Not supported)"); return; }
	bvp = (byte far *)vp;
	printf("PM-I/F table    %Fph\n", vp);
	printf("Size of table   %04Xh (%u Bytes)\n", bytes, bytes);
	printf("Func 05  offset %04Xh (%Fph)\n", vp->off_func5, bvp + vp->off_func5);
	printf("Func 07  offset %04Xh (%Fph)\n", vp->off_func7, bvp + vp->off_func7);
	printf("Func 09  offset %04Xh (%Fph)\n", vp->off_func9, bvp + vp->off_func9);
	printf("Port&Mem offset %04Xh ", vp->off_portmem);
	if (0 == vp->off_portmem)	puts("(none)");
	else
		{
		bvp += vp->off_portmem;
		printf("(%Fph)\n", bvp);
		printf("I/O ports...");
		bvp += sizeof(word) * (PrintWordTable((word far *)bvp) + 1);
		printf("Memory location...\n");
		if (0xffffU == *(word far *)bvp)	puts("    (none)");
		else
			{
			dw = *(dword far *)bvp;
			w = *(word far *)(bvp + sizeof(dword));
			printf("    %08lXh-%08lXh (%u Bytes)\n", dw, dw + w - 1, w);
			bvp += sizeof(dword) + sizeof(word);
			}
		}
}

void
PrintVbe3pm16(PMINFOBLK far *pmid)
{
	printf("PMInfoBlock at  %Fph\n", pmid);
	printf("PM Entry Point  %04Xh (%04X:%04Xh)\n", pmid->off_bios, (word)((dword)pmid >> 16), pmid->off_bios);
	printf("PM Initialize   %04Xh (%04X:%04Xh)\n", pmid->off_init, (word)((dword)pmid >> 16), pmid->off_init);
}

void
PrintVesamSOnce(VESAI * vi, VESAM * vm, word mode, int pixmap)
{
	QueryVesam(vm, mode);
	PrintVesamS(vm, mode, vi->ver, pixmap);
}

void
PrintVesamSAll(VESAI * vi, VESAM * vm, int pixmap)
{
	word far *	lpm;
	word		m;
	
	printf("Mode   Reso    Color Wnd-A  Wnd-B Siz Gr Wnd-Func  Linear");
	if (pixmap) printf("   ColorMap");
	printf("\n");
	
	lpm = vi->vm;
	while(0xffffU != (m = *lpm++))
		PrintVesamSOnce(vi, vm, m, pixmap);
	
}

void
PrintVesamOnce(VESAM * vm, word mode, word ver)
{
	word	stat;
	
	printf("[Mode %4Xh]\n", mode);
	stat = QueryVesam(vm, mode);
	if (0x004f != stat)	{ ErrVesa(stat); return; }
	PrintVesam(vm, ver);
}

void
PrintVbe2pm32Once(void)
{
	word		stat;
	word		bytes;
	VBEPM far *	vp;
	
	puts("\n[VBE 2.0 32bit protected mode interface]");
	stat = QueryVbe2pm32(&vp, &bytes);
	if (0x004f != stat)	{ ErrVesa(stat); return; }
	PrintVbe2pm32(vp, bytes);
}

void
PrintVbe3pm16Once(word vgaromseg)
{
	PMINFOBLK far *pmid;
	long initlen;
	word pcir;
	puts("\n[VBE 3.0 16bit protected mode interface]");
	
	if (!QueryRomSize(vgaromseg, &initlen, &pcir))
		{
		printf("VGAROM is not present at %X0h\n", vgaromseg);
		return;
		}
	
	if (initlen > 32768) initlen = 32768;
	pmid = ScanPMInfoBlock(vgaromseg, 0, (word)(unsigned long)initlen);
	if (pmid == 0L)
		{
		printf("PMInfoBlock is not present in VGA-ROMBIOS (%04X:0000h-%04X:%04Xh).\n", vgaromseg, vgaromseg, (initlen - 1));
		return;
		}
	PrintVbe3pm16(pmid);
}


void
DumpVesai(void)
{
	byte *p;
	VESAI *v1, *v2;
	int i;
	
	p = (byte *)malloc(512 * 3);
	if (!p)
		{
		printf("vbei memory error.\n");
		exit(1);
		}
	v1 = (VESAI *)p;
	v2 = (VESAI *)(p + 512);
	
	memset(v1, 0x00, 512); QueryVesai(v1, 1);
	memset(v2, 0xff, 512); QueryVesai(v2, 1);
	for(i=0; i<512; i++)
		p[1024+i] = (p[i] == p[512+i]);
	
	dumpmem_um((byte far *)p, (byte far *)(p + 1024), 512);
	free(p);
}

void
DumpVesam(word mode)
{
	byte *p;
	VESAM *v1, *v2;
	int i;
	
	p = (byte *)malloc(256 * 3);
	if (!p)
		{
		printf("vbei memory error.\n");
		exit(1);
		}
	v1 = (VESAM *)p;
	v2 = (VESAM *)(p + 256);
	
	memset(v1, 0x00, 256); QueryVesam(v1, mode);
	memset(v2, 0xff, 256); QueryVesam(v2, mode);
	for(i=0; i<256; i++)
		p[512+i] = (p[i] == p[256+i]);
	
	dumpmem_um((byte far *)p, (byte far *)(p + 512), 256);
	free(p);
}

static word vgaromseg = 0xc000U;

static int	optS = 0;
static int	optHelp = 0;
static int	optX = 0;
static int	optDump = 0;
static int	mmodify = 0;
static word	mode;
static char *romimgfn = NULL;

int
getp(int argc, char **argv)
{
	const char srom[] = "romimage=";
	const char sdump[] = "dump";
	int		result = 1;
	char *	p;
	int		mm;
	
	argc--;
	argv++;
	mm = 0;
	
	while(argc--)
		{
		p = *argv++;
		if ('-' == *p || '/' == *p)
			{
			if (strcmpi(p + 1, sdump) == 0) optDump = 1;
			if (memicmp(p + 1, srom, strlen(srom)) == 0)
				{
				romimgfn = p + strlen(srom) + 1;
				}
			if ('s' == p[1] || 'S' == p[1])	optS = 1;
			if ('x' == p[1] || 'X' == p[1])
				{
				optX = strtol(p + 2, NULL, 16);
				}
			if ('?' == p[1])	optHelp = 1;
			}
		else
			{
			if (0 == mm)
				{
				mode = 0;
				sscanf(p, "%x", &mode);
				result = (mode != 0);
				mmodify =1;
				mm++;
				}
			}
		}
	
	return result;
}


#if 1


void far *
aligned_malloc(long size, long align)
{
	char far *s;
	char far *sa;
	unsigned long dw;
	if (align <= 0) align =16;
	
	dw = size + align - 1;
	size = dw - (dw % align);
	size += 16;
	s = (char far *)farmalloc(size);
	if (s) {
		dw = ((unsigned long)s + align - 1);
		dw -= (dw % align);
		dw += 16;
		sa = (char far *)dw;
		*(unsigned long far *)(dw - 4) = (unsigned long)s;
	}
	else {
		sa = 0L;
	}
	
	return sa;
}

void
aligned_free(void far *p)
{
	if (!p) return;
	farfree((void far *)*(unsigned long *)((unsigned long)p - 4));
}


void far *
readfile(const char *fn, long *filesize)
{
	void far *p;
	char far *s;
	int c;
	FILE *fi;
	long len, lcnt;
	
	fi = fopen(fn, "rb");
	if (fi == NULL) return 0L;
	fseek(fi, 0L, SEEK_END);
	len = ftell(fi);
	p = aligned_malloc(len, 16);
	if (p) {
		fseek(fi, 0L, SEEK_SET);
		lcnt = len;
		s = (char far *)p;
		
		while(lcnt > 0) {
			c = fgetc(fi);
			if (c == EOF) break;
			*s = (char)c;
			s++;
			lcnt--;
		}
	}
	fclose(fi);
	if (filesize != NULL) *filesize = len;
	return p;
}
#endif


void
main(int argc, char **argv)
{
	char		bufi[512];
	char		bufm[256];
	VESAI *		vi;
	VESAM *		vm;
	VBESUP *	vs;
	word		stat;
	void far *	romimg;
	long		romimgsize;
	
	getp(argc, argv);
	if (optHelp)
		{
		printf("VBEI version %x.%02x%s  (c)sava/LP-Project. 1996-2004\n"
				,major, minor, ver_trailer);
		puts("Show VESA BIOS (VBE) information.\n"
		     "Usage : vbei [-s] [-dump] [videomode(hex)]\n"
		     "         -s       simply display.\n"
		     "         -dump    dump information block.\n"
#if 0
		     "         -x       get supplemental specification info.\n"
		     "         -romimage=romimagefilename\n"
		     "                  load ROM image and display infomation.\n"
#endif
		    );
		return;
		}
	
	if (romimgfn != NULL)
		{
		romimg = readfile(romimgfn, &romimgsize);
		if (romimg == (void far *)0L)
			{
			printf("Read Failure - file '%s'\n", romimgfn);
			return;
			}
		vgaromseg = (dword)romimg >> 16;
		if ((word)romimg != 0)
			vgaromseg += ((word)romimg >> 4);
		
		printf("[ROM image '%s']\n", romimgfn);
		printf("image loaded at %Fph (%04X:0000h)\n", romimg, vgaromseg);
		printf("file size       %lXh (%ld bytes)\n", romimgsize, romimgsize);
		
		PrintVgaRomInfo(vgaromseg);
		PrintVbe3pm16Once(vgaromseg);
		
		aligned_free(romimg);
		return;
		}
	
	memset(bufi, 0, sizeof(bufi));
	memset(bufm, 0, sizeof(bufm));
	vi = (VESAI *)bufi;
	vm = (VESAM *)bufm;
	
	stat = QueryVesai(vi, 1);
	if (0x004f != stat)	{ ErrVesa(stat); return; }
	if (optS)
		{
		if (mmodify)	PrintVesamSOnce(vi, vm, mode, 1);
		else			PrintVesamSAll(vi, vm, 1);
		}
	else if (optX > 0)
		{
		vs = (VBESUP *)bufm;
		memset(bufm, 0, sizeof(VBESUP));
		stat = QueryVbesup(vs, optX);
		if (memcmp(bufm, "VBE/", 4) != 0)
			{
			printf("VBE supplemental Function %02xh - information not supported\n", optX);
			if (stat != 0x004f) ErrVesa(stat);
			return;
			}
		PrintVbesup(vs);
		}
	else
		{
		if (mmodify)
			{
			if (0 == mode)	puts("Type \"vbei -?\" to help.");
			else
				{
				PrintVesamOnce(vm, mode, vi->ver);
				if (optDump)
					{
					printf("\n[ModeInfoBlock dump]\n");
					DumpVesam(mode);
					}
				}
			}
		else
			{
			PrintVgaRomInfo(vgaromseg);
			/*
			PrintVgaBiosInfo();
			*/
			PrintVesai(vi);
			if (0x0200 <= vi->ver)	PrintVbe2pm32Once();
			if (0x0300 <= vi->ver)	PrintVbe3pm16Once(vgaromseg);
			PrintVbeDPMS();
			PrintVbeDDC();
			
			if (optDump)
				{
				printf("\n[VbeInfoBlock dump]\n");
				DumpVesai();
				}
			}
		}
}
